function Speller(args) {
    args = args || new Object;
    this.url = args.url || ".";
    this.args = {
        defLang: args.lang, defOptions: args.options,
        spellDlg: args.spellDlg || { width: 440, height: 280 },
        optDlg: args.optDlg || { width: 330, height: 275 },
        userDicDlg: args.userDicDlg || { width: 270, height: 350 }
    };
}

Speller.IGNORE_UPPERCASE = 0x0001;
Speller.IGNORE_DIGITS    = 0x0002;
Speller.IGNORE_URLS      = 0x0004;
Speller.FIND_REPEAT      = 0x0008;
Speller.IGNORE_LATIN     = 0x0010;
Speller.FLAG_LATIN       = 0x0080;

Speller.prototype.check = function(ctrls) {
    this.showDialog(this.url + "/spelldlg.html", this.args.spellDlg, ctrls);
}

Speller.prototype.optionsDialog = function() {
    this.showDialog(this.url + "/spellopt.html", this.args.optDlg);
}

Speller.prototype.showDialog = function(url, size, ctrls) {
    var a = this.args;
    var args = { ctrls: ctrls, lang: a.lang, options: a.options,
        defLang: a.defLang, defOptions: a.defOptions,
        optDlg: a.optDlg, userDicDlg: a.userDicDlg };
    if (window.showModalDialog) {
        var features = "dialogWidth:" + size.width + "px;dialogHeight:" + size.height + "px;scroll:no;help:no;status:no";
        window.showModalDialog(url, args, features);
        a.lang = args.lang; a.options = args.options;
    }
    else {
        var name = url.replace(/[\/\.]/g, "");
        var features = "width=" + size.width + ",height=" + size.height + ",toolbar=no,status=no,menubar=no,directories=no,resizable=no";
        window.theDlgArgs = args;
        var dlg = window.open(url, name, features);
        dlg.onunload = function() {
            a.lang = args.lang; a.options = args.options;
        }
    }
}



var speller = new Speller({
	url: "/clientscript/speller",
	lang: "ru",
	options: Speller.IGNORE_UPPERCASE + Speller.IGNORE_DIGITS + Speller.IGNORE_URLS + Speller.FIND_REPEAT
});

function spellCheck() {
	var spell_arr = [];
	if (typeof(document.vbform.message) == 'object') spell_arr.push(document.vbform.message);
	if (typeof(document.vbform.subject) == 'object') spell_arr.push(document.vbform.subject);
	if (typeof(document.vbform.title) == 'object') spell_arr.push(document.vbform.title);
	if(spell_arr) speller.check(spell_arr);
	else alert('   ');
}

document.write('<button class="button" name="cmdSpell" type="button" onclick="spellCheck()"></button>');
/*
[ document.vbform.message, document.vbform.subject ]
document.write(' <button class="button" name="cmdOptions" type="button" onclick="speller.optionsDialog()"> </button> ');
*/